import ConfigParser
import logging
import tempfile

log = logging.getLogger(__name__)

try:
    from launchpadlib.launchpad import Launchpad
except ImportError:
    log.info("Please install launchpadlib in your virtual env")


def generate_credentials():
    """Generate Launchpad credentials.

    Prints out Launchpad credentials based on manual login performed by
    human in browser.
    """
    credentials_file = tempfile.NamedTemporaryFile()

    Launchpad.login_with(application_name='lp-reports',
                         service_root='https://api.launchpad.net/',
                         credentials_file=credentials_file.name)

    config = ConfigParser.ConfigParser()
    config.readfp(credentials_file)

    print("Copy the following to lp-reports config:\n")
    print("LP_CONSUMER_KEY : \"{0}\"".format(config.get("1", "consumer_key")))
    print("LP_TOKEN : \"{0}\"".format(config.get("1", "access_token")))
    print("LP_SIGNATURE : \"%26{0}\"".format(config.get("1", "access_secret")))

    credentials_file.close()
