"""
This file contains class `BugTask` that creates bug task from bug object.
"""


from lpreports.launchpad.milestone import Milestone

ATTRIBUTES_TO_COPY = (
    "id",
    "assignee_link",
    "assignee",
    "importance",
    "status",
    "date_last_updated",
)


class BugTask(object):
    def __init__(self, bug):
        # copy attributes from the bug
        for attr in ATTRIBUTES_TO_COPY:
            setattr(self, attr, getattr(bug, attr))
        self.milestone = Milestone(bug.milestone) if bug.milestone else None
