class Milestone(object):
    """The class implements milestone object."""

    def __init__(self, version):
        self.version = version if version else ''
        self.numbers = ()
        self.suffix = None
        self.is_next = False
        if self.version.startswith('next'):
            self.is_next = True
        else:
            version_lst = self.version.split('-', 1)
            self.numbers = tuple(int(n) for n in version_lst[0].split('.') if n.isdigit())
            self.suffix = version_lst[1] if len(version_lst) > 1 else None

    def __repr__(self):
        return '<{0}: {1}>'.format(self.__name__, self.version)

    def __str__(self):
        return self.version

    def __cmp__(self, other):
        if not other:
            return 1

        if not isinstance(other, type(self)):
            other = type(self)(other)

        if self.is_next and other.is_next:
            return 0
        elif other.is_next:
            return -1
        elif self.is_next:
            return 1

        if self.numbers > other.numbers:
            return 1
        elif self.numbers < other.numbers:
            return -1

        if self.suffix > other.suffix:
            return 1
        elif self.suffix < other.suffix:
            return -1

        return 0
