from datetime import datetime

import six


class Weekday(object):
    MONDAY = 0
    TUESDAY = 1
    WEDNESDAY = 2
    THURSDAY = 3
    FRIDAY = 4
    SATURDAY = 5
    SUNDAY = 6

    @classmethod
    def by_name(cls, name):
        try:
            return getattr(cls, six.text_type(name).upper())
        except AttributeError:
            raise ValueError(
                '{name} is an invalid week day name. Valid names are: MONDAY, '
                'TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY.'.format(name=name)
            )


def select_keys(d, keys):
    return {k: d.get(k, None) for k in keys}


def timestamp_to_utc_date(timestamp):
    return (datetime.fromtimestamp(timestamp).
            strftime('%Y-%m-%d'))
