function make_query_string() {
    var query_str = "";
    var searchform = $(".searchform");

    searchform.find("#target_name_select option:selected").each(function () {
        query_str += "&project=" + $(this).text();
    });

    searchform.find("#importance_select option:selected").each(function () {
        query_str += "&importance=" + $(this).text();
    });

    searchform.find("#assignee_select option:selected").each(function () {
        query_str += "&assignee=" + $(this).text();
    });

    query_str += text_to_query_str("#tags_select", "tags");
    query_str += text_to_query_str("#exclude_tags_select", "exclude_tags");

    query_str += "&initial_date=" + $("#initial_date").val();

    return query_str.substr(1, query_str.length);
}

function redraw() {
    var query_str = make_query_string();
    var current_milestone = $('#list_milestones .active').text();
    var bug_trends_data_url = '/charts/api/bug_trends/' + current_milestone + '?' + query_str;
    var in_out_data_url = '/charts/api/incoming_outgoing/' + current_milestone + '?' + query_str;

    push_state('/charts/product/' + current_milestone + '?' + query_str);

    render_bug_trends('bug-report-chart', bug_trends_data_url);
    render_burndown_chart('bug-burndown-chart', bug_trends_data_url);

    render_in_out_bugs('bug-incoming-outgoing-chart', in_out_data_url);
}

function parse_query_string(queryString) {
    var params = {};
    var queries = [];
    var param, key, val;

    if (queryString) {
        queries = queryString.split("?")[1].split("&");
    }

    for (var q in queries) {
        param = queries[q].split('=');
        key = param[0];
        val = param[1];

        if (!params[key]) {
            params[key] = [];
        }
        params[key].push(val)
    }

    return params;
}

function push_state(url) {
    history.pushState({}, "", url);
}

function restore_state() {
    var params = parse_query_string(location.search);
    var tags = params.tags || params.tags_all;
    var exclude_tags = params.exclude_tags || params.exclude_tags_all;

    if (params.project) {
        $("#target_name_select").multipleSelect("setSelects", params.project);
    }
    if (params.importance) {
        $("#importance_select").multipleSelect("setSelects", params.importance);
    }
    if (params.assignee) {
        $("#assignee_select").multipleSelect("setSelects", params.assignee);
    }
    if (tags) {
        $("#tags_select").val(tags.join(" "));
    }
    if (exclude_tags) {
        $("#exclude_tags_select").val(exclude_tags.join(" "));
    }
    if (params.initial_date) {
        $("#initial_date").val(params.initial_date[0]);
    }

    if (params.tags_all) {
        $("#tags_switch").bootstrapSwitch('state', true);
    }
    if (params.exclude_tags_all) {
        $("#exclude_tags_switch").bootstrapSwitch('state', true);
    }
}

$(document).ready(function() {
    restore_state();
    redraw();
});
